## net.sf.saxon.functions
Class DistinctValues.DistinctIterator

    java.lang.Object
      net.sf.saxon.functions.DistinctValues.DistinctIterator

All Implemented Interfaces:
  SequenceIterator

Enclosing class:
  DistinctValues

    public static class DistinctValues.DistinctIterator

extends java.lang.Object
implements SequenceIterator

Iterator class to return the distinct values in a sequence

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`DistinctValues.DistinctIterator(SequenceIterator base, AtomicComparer comparer)` Create an iterator over the distinct values in a sequence

Method Summary
`void` `close()` Close the iterator.
`Item` `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
`SequenceIterator` `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
`int` `getProperties()` Get properties of this iterator, as a bit-significant integer.
`Item` `next()` Get the next item in the sequence.
`int` `position()` Get the current position.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DistinctValues.DistinctIterator

    public DistinctValues.DistinctIterator(SequenceIterator base,
                                           AtomicComparer comparer)

  Create an iterator over the distinct values in a sequence

  Parameters:
    `base` - the input sequence. This must return atomic values only.
    `comparer` - The comparer used to obtain comparison keys from each value; these comparison keys are themselves compared using equals().

Method Detail

### next

    public Item next()
              throws XPathException

  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator`
  Returns:
    the next item, or null if there are no more items.
  Throws:
    `XPathException` - if an error occurs retrieving the next item

### current

    public Item current()

  Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next().

  Specified by:
    `current` in interface `SequenceIterator`
  Returns:
    the current item, the one most recently returned by a call on next(); or null, if next() has not been called, or if the end of the sequence has been reached.

### position

    public int position()

  Get the current position. This will be zero before the first call on next(), otherwise it will be the number of times that next() has been called.

  Specified by:
    `position` in interface `SequenceIterator`
  Returns:
    the current position, the position of the item returned by the most recent call of next()

### close

    public void close()

  Description copied from interface: `SequenceIterator`
  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Specified by:
    `close` in interface `SequenceIterator`

### getAnother

    public SequenceIterator getAnother()
                                throws XPathException

  Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Returns:
    a SequenceIterator that iterates over the same items, positioned before the first item
  Throws:
    `XPathException` - if any error occurs

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Copyright (c) Saxonica Limited. All rights reserved.